//+-------------------------------------------------------------------------------------+
//|                                                                PChannel_Percent.mq4 |
//+-------------------------------------------------------------------------------------+

#property indicator_chart_window             //     ( )
#property indicator_buffers 4                                    //   
#property indicator_color1 DodgerBlue //      1 
#property indicator_color2 DodgerBlue //      2 
#property indicator_color3 DodgerBlue //      3 
#property indicator_color4 DodgerBlue //      3 

extern string A1           = " ,     ";
extern int    Range        = 14; 
extern string A2           = "======================================================";
extern string A3           = "      ";
extern double PercentLevel = 10.0; 
extern string A4           = "======================================================";


double UpBuffer[];              //       
double DnBuffer[];               //       
double UpPerBuffer[];       //       
double DnPerBuffer[];        //       
double PL;                    //  PercentLevel     
bool Activate;                                                     //   

//+-------------------------------------------------------------------------------------+
//|                                                       |
//+-------------------------------------------------------------------------------------+
int init() 
  {
   Activate = False;
// - 1 - ===================    ================================
   SetIndexStyle(0, DRAW_LINE, STYLE_DOT);                //    
   SetIndexStyle(1, DRAW_LINE, STYLE_DOT);                 //    
   SetIndexStyle(2, DRAW_LINE, STYLE_DASH, 2); //     
   SetIndexStyle(3, DRAW_LINE, STYLE_DASH, 2);  //     
   SetIndexBuffer(0, UpBuffer);   //    0    UpBuffer
   SetIndexBuffer(1, DnBuffer);   //    1    DnBuffer
   SetIndexBuffer(2, UpPerBuffer);      //    2   UpPerBuffer
   SetIndexBuffer(3, DnPerBuffer);      //    2   DnPerBuffer
// - 1 - ==========================   =====================================

// - 2 - ===================      =============================
   IndicatorShortName("PriceChannel (" + Range + ") with Percent (" + PercentLevel +")");  
   SetIndexLabel(0, "  ");          //    
   SetIndexLabel(1, "  ");           //    
   SetIndexLabel(2, "  ");           //   
   SetIndexLabel(3, "  ");            //   
// - 2 - ==========================   =====================================

// - 3 - ===================     ===================
   if (Range < 1)
     {
      Alert("   Range.  PChannel_Percent !");
      Print("   Range.  PChannel_Percent !");
      return(0);
     }
   if (PercentLevel < -49.0)
     {
      Alert("  PercentLevel.  PChannel_Percent !");
      Print("  PercentLevel.  PChannel_Percent !");
      return(0);
     }
     
   PL = PercentLevel/100.0;
// - 3 - ==========================   =====================================

   Activate = True;                                      //   

   return(0); 
  }
  
//+-------------------------------------------------------------------------------------+
//|                                                        |
//+-------------------------------------------------------------------------------------+
int start() 
  {
// - 1 - ======================    ? ===========================
   if (!Activate) return(0);
// - 1 - ==========================   =====================================
   
// - 2 - ======   -     ===========
   int cnt = IndicatorCounted();   //       
   if (cnt > 0) cnt--;                 // ,      
   int limit = Bars - cnt;         //   ,   
// - 2 - ==========================   =====================================
   
// - 3 - ======================       =====================
   for (int i = limit; i >= 0; i--)    //    ,  
     {
      //   -    Range 
      UpBuffer[i] = High[iHighest(NULL, 0, MODE_HIGH, Range, i)]; 
      
      //   -    Range 
      DnBuffer[i] = Low[iLowest(NULL, 0, MODE_LOW, Range, i)];
      
      //   ,      
      double Level = (UpBuffer[i] - DnBuffer[i])*PL;
      
      UpPerBuffer[i] = UpBuffer[i] + Level;          //    
      DnPerBuffer[i] = DnBuffer[i] - Level;           //    
     }
// - 3 - ==========================   =====================================
     
   return(0);
  }


